define([
    "jquery",
    'Magento_Ui/js/modal/modal',
    "jquery/ui",
    "mage/cookies",
    "mage/translate"
], function ($, modal) {
    "use strict";

    //creating jquery widget
    $.widget('filoblu.geoip_popup', {
        _create: function () {

            var options = this.options;
            var me = this;

            var optionsPopup = {
                type: 'popup',
                responsive: true,
                modalClass: 'geoipModal',
                innerScroll: true,
                autoOpen: options.auto_open,
//                title: $.mage.__('Choose Your Country'),
                buttons: [],
                closed: function () {
                    $(options.popup_id).addClass("selected-step-first").removeClass("selected-step-second");
                },
                opened: function ($Event) {
                    if (options.auto_open) {
                        $('.modal-header button.action-close', $Event.srcElement).hide();
                    }
                },
                keyEventHandlers: {

                    escapeKey: function () {
                        if (options.auto_open) {
                            return;
                        }
                    }
                }
            };

            var popup = modal(optionsPopup, $(options.popup_id));

            $(options.current_choose_country_link).on("click", function (e) {

                e.preventDefault();
                $(options.popup_id).removeClass("selected-step-second").addClass("selected-step-first");

            });
            
            $(options.country_link).on("click", function (e) {

                e.preventDefault();
                me._countryAjax($(this).attr("href"), $(this).data("store-id"), $(this).data("country-id"), $(this).data("country-name"), options);

            });

            $("body").on('click', options.language_link, function (e) {
                
                e.preventDefault();
                me._languageAjax($(this).attr("href"), $(this).attr("data-store-id"), $(this).attr("data-country-id"));
            });

            $(options.shipping_to_link).on("click", function (e) {

                e.preventDefault();
                $(options.popup_id).modal("openModal");

            });

        },
        _countryAjax: function (url, store_id, country_id, country_name, options) {
            $.ajax({
                showLoader: true,
                url: url + "geoip/change/country",
                data: "store_id=" + store_id + "&country_id=" + country_id,
                type: "POST",
                dataType: 'json'
            }).done(function (languages) {

                if (languages.length == 1) {
                    window.location.href = languages[0].url;
                } else {
                    var languageList = "";
                    languages.forEach(function (entry) {
                        var languageName = "";
                        if (options.auto_open) {
                            languageName = entry.name;
                        }
                        else {
                            languageName = $.mage.__(entry.name);
                        }
                        
                        languageList += "<a class='language-link' href='" + entry.url + "' data-store-id='" + entry.store_id + "' data-country-id='" + entry.country_id + "' >" + languageName + "</a>";
                    });

                    $(options.language_list_container).html(languageList);
                    $(options.current_choose_country_link).html(country_name);
                    
                    $(options.popup_id).removeClass("selected-step-first").addClass("selected-step-second");

                }
            });
        },
        _languageAjax: function (url, store_id, country_id) {
            $.ajax({
                showLoader: true,
                url: url + "geoip/change/language",
                data: "store_id=" + store_id + "&country_id=" + country_id,
                type: "POST",
                dataType: 'json'
            }).done(function (result) {

                if (result) {
                    window.location.href = result.url;
                }
            });
        }

    });

    return $.filoblu.geoip_popup;
});
